#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>

void clear_append(int fd) {
    int oflags;
        /* oflags mittels fcntl() ermitteln */
    if ((oflags = fcntl(fd, F_GETFL, 0)) < 0)
	perror("fcntl"), exit(1);

    /* Ist O_APPEND gesetzt? Wenn nein, dann fertig! */
    if ((oflags & O_APPEND) != O_APPEND)
	return;

    oflags &= ~O_APPEND;	/* O_APPEND loeschen */
    
    /* veraenderte oflags setzen */
    if (fcntl(fd, F_SETFL, oflags) < 0)
	perror("fcntl"), exit(2);
}

int main() {
    char buf[20];
    int fd, n;

    if ((fd = open("file", O_RDWR | O_CREAT | O_TRUNC | O_APPEND, 0644)) < 0)
	perror("open"), exit(3);

    write(fd, "aaaaa", 5);	/* "aaaaa" in die Datei schreiben */

    lseek(fd, 0, SEEK_SET);
    write(fd, "bbbb", 4);	/* haengt "bbbb" an -- wg. O_APPEND! */

    clear_append(fd);		/* O_APPEND loeschen */

    lseek(fd, 0, SEEK_SET);
    write(fd, "ccc", 3);	/* jetzt wird "ccc" tatsaechlich am Anfang geschr. */

    lseek(fd, 0, SEEK_SET);	/* vom Anfang an ... */
    n = read(fd, buf, 19);	/* auslesen ...*/
    buf[n] = '\0';
    puts(buf);			/* ... und ausgeben */

    close(fd);			/* wuerde auch implizit passieren */

    return 0;
}
