/*
 * Programm schaltet Echo aus.
 * VORSICHT! Danach sieht man nicht
 * mehr, was auf dem Terminal eingegeben wird!
 */

#include <unistd.h>
#include <termio.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

void echo_off(int fd) {
    struct termio buf;
    /* Flags lesen ... */
    if (ioctl(fd, TCGETA, &buf) < 0)
	perror("ioctl"), exit(1);

    /* ECHO nicht gesetzt? => nichts zu tun */
    if ((buf.c_lflag & ECHO) != ECHO)
	return;

    buf.c_lflag &= ~ECHO;	/* ECHO loeschen */
    
    /* Flags setzen ... */
    if (ioctl(fd, TCSETA, &buf) < 0)
	perror("ioctl"), exit(2);
}

int main() {
    echo_off(0);	/* Echo ausschalten */
    return 0;
}
