/*
 * Programm schaltet Echo an.
 * Wird unbedingt in Kombination mit off.c benoetigt!
 */

#include <unistd.h>
#include <termio.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

void echo_on(int fd) {
    struct termio buf;
    /* Flags lesen ... */
    if (ioctl(fd, TCGETA, &buf) < 0)
	perror("ioctl"), exit(1);

    /* ECHO gesetzt? => nichts zu tun */
    if ((buf.c_lflag & ECHO) == ECHO)
	return;

    buf.c_lflag |= ECHO;	/* ECHO setzen */
    
    /* Flags setzen ... */
    if (ioctl(fd, TCSETA, &buf) < 0)
	perror("ioctl"), exit(2);
}

int main() {
    echo_on(0);		/* Echo einschalten */
    return 0;
}
